//+----------------------------------------------------------------------------+
//|                                                            b-SendMail.mqh  |
//|                                                      . aka KimIV  |
//|                                                       http://www.kimiv.ru  |
//|                                                                            |
//|  29.06.2007      .               |
//|                                                                            |
//|       :                            |
//|  -         : #include <b-SendMail.mqh>                           |
//|  -   start() : if (UseSendMail) AccountState();                    |
//+----------------------------------------------------------------------------+
//#property library

//-------    --------------------------------------------+
extern string _P_b_SendMail = "----------   b-SendMail";
extern bool UseSendMail       = True;     //   
extern bool SendAccountNumber = True;     //   
extern bool SendAccountServer = True;     //    
extern bool SendNameExpert    = True;     //   
extern bool SendDateTime      = True;     //    
extern bool UseTimeLocal      = True;     //   
extern bool SendTicket        = False;    //  

//-------    ----------------------------------------+
int    bsmOTI[];             //    OrderTicket()
int    bsmOTY[];             //      OrderType()
double bsmOOP[];             //     OrderOpenPrice()
double bsmOSL[];             //     OrderStopLoss()
double bsmOTP[];             //     OrderTakeProfit()
bool   bsmFirstRun=True;     //   

//+----------------------------------------------------------------------------+
//|    .    start .            |
//|                                  |
//|       .                          |
//+----------------------------------------------------------------------------+
void AccountState() {
  double p;                  //     
  int    d;                  //       
  int    i;                  //  
  int    in;                 //    
  int    k=OrdersTotal();    //   
  int    ot;                 //   OrderType()
  int    oti[];              //   
  string sh="";              //    
  string st;                 //    

  if (bsmFirstRun) { MemCurrOP(); bsmFirstRun=False; }
  if (SendAccountNumber) sh=DoubleToStr(AccountNumber(), 0)+" ";
  if (SendAccountServer) sh=sh+AccountServer();
  if (StringLen(sh)>0) sh=sh+"\n";
  if (SendDateTime) {
    if (UseTimeLocal) sh=sh+TimeToStr(TimeLocal(), TIME_DATE|TIME_MINUTES)+" ";
    else sh=sh+TimeToStr(TimeCurrent(), TIME_DATE|TIME_SECONDS)+" ";
  }
  if (SendNameExpert) sh=sh+WindowExpertName()+" ";
  if (StringLen(sh)>0) sh=sh+"\n";
  
  // / ,  
  ArrayResize(oti, k);
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      oti[i]=OrderTicket();
      d=MarketInfo(OrderSymbol(), MODE_DIGITS);
      p=MarketInfo(OrderSymbol(), MODE_POINT);
      in=ArraySearchInt(bsmOTI, oti[i]);

      //   ,  
      if (in<0) {
        ot=OrderType();
        if (ot==OP_BUY || ot==OP_SELL) st="Open ";
        if (ot==OP_BUYLIMIT || ot==OP_BUYSTOP
        ||  ot==OP_SELLLIMIT || ot==OP_SELLSTOP) st="Set ";
        if (SendTicket) st=st+DoubleToStr(OrderTicket(), 0)+" ";
        st=st+GetNameOP(ot)+" "
             +DoubleToStr(OrderLots(), 2)+" "
             +OrderSymbol()
             +" PR="+DoubleToStr(OrderOpenPrice(), d)
             +" SL="+DoubleToStr(OrderStopLoss(), d)
             +" TP="+DoubleToStr(OrderTakeProfit(), d)
             +"\n";
        if (ot==OP_BUY || ot==OP_SELL) {
          st=st+"Balance="+DoubleToStr(AccountBalance(), 2)
               +" FreeMargin="+DoubleToStr(AccountFreeMargin(), 2);
        }
        if (StringLen(sh)>0) st=sh+st;
        SendMail(WindowExpertName(), st);

      //  ,      
      } else {
        if ((MathAbs(OrderOpenPrice()-bsmOOP[in])>=p)
        ||  (MathAbs(OrderStopLoss()-bsmOSL[in])>=p)
        ||  (MathAbs(OrderTakeProfit()-bsmOTP[in])>=p)) {
          st="Modify ";
          if (SendTicket) st=st+DoubleToStr(OrderTicket(), 0)+" ";
          st=st+GetNameOP(OrderType())+" "
            +DoubleToStr(OrderLots(), 2)+" "
            +OrderSymbol();
          //   
          if (MathAbs(OrderOpenPrice()-bsmOOP[in])>=p) {
            st=st+" PR="+DoubleToStr(bsmOOP[in], d)+"->"+DoubleToStr(OrderOpenPrice(), d);
          }
          //   
          if (MathAbs(OrderStopLoss()-bsmOSL[in])>=p) {
            st=st+" SL="+DoubleToStr(bsmOSL[in], d)+"->"+DoubleToStr(OrderStopLoss(), d);
          }
          //   
          if (MathAbs(OrderTakeProfit()-bsmOTP[in])>=p) {
            st=st+" TP="+DoubleToStr(bsmOTP[in], d)+"->"+DoubleToStr(OrderTakeProfit(), d);
          }
          if (StringLen(sh)>0) st=sh+st;
          SendMail(WindowExpertName(), st);
        }
      }
    }
  }

  // / ,  
  k=ArraySize(bsmOTI);
  for (i=0; i<k; i++) {
    if (ArraySearchInt(oti, bsmOTI[i])<0) {
      ot=bsmOTY[i];
      if (ot==OP_BUY || ot==OP_SELL) st="Close ";
      if (ot==OP_BUYLIMIT || ot==OP_BUYSTOP
      ||  ot==OP_SELLLIMIT || ot==OP_SELLSTOP) st="Delete ";
      if (SendTicket) st=st+DoubleToStr(bsmOTI[i], 0)+" ";
      if (SelectByTicketFromHistory(bsmOTI[i])) {
        d=MarketInfo(OrderSymbol(), MODE_DIGITS);
        st=st+GetNameOP(ot)+" "
             +DoubleToStr(OrderLots(), 2)+" "
             +OrderSymbol()
             +" PR="+DoubleToStr(OrderClosePrice(), d)
             ;
        if (ot==OP_BUY || ot==OP_SELL) {
          st=st+" Profit="+DoubleToStr(OrderProfit()+OrderSwap(), 2)
               +"\n"
               +"Balance="+DoubleToStr(AccountBalance(), 2)
               +" FreeMargin="+DoubleToStr(AccountFreeMargin(), 2);
        }
        if (StringLen(sh)>0) st=sh+st;
        SendMail(WindowExpertName(), st);
      }
    }
  }

  MemCurrOP();
}

//+----------------------------------------------------------------------------+
//|                                     |
//|        -1                            |
//|  :                                                                |
//|    m -                                                      |
//|    e -                                                     |
//+----------------------------------------------------------------------------+
int ArraySearchInt(int& m[], int e) {
  for (int i=0; i<ArraySize(m); i++) {
    if (m[i]==e) return(i);
  }
  return(-1);
}

//+----------------------------------------------------------------------------+
//|                                      |
//|  :                                                                |
//|    op -                                       |
//+----------------------------------------------------------------------------+
string GetNameOP(int op) {
	switch (op) {
		case OP_BUY      : return("Buy");
		case OP_SELL     : return("Sell");
		case OP_BUYLIMIT : return("Buy Limit");
		case OP_SELLLIMIT: return("Sell Limit");
		case OP_BUYSTOP  : return("Buy Stop");
		case OP_SELLSTOP : return("Sell Stop");
		default          : return("Unknown Operation");
	}
}

//+----------------------------------------------------------------------------+
//|      .                                    |
//+----------------------------------------------------------------------------+
void MemCurrOP() {
  int i, k=OrdersTotal();

  ArrayResize(bsmOTI, k);
  ArrayResize(bsmOTY, k);
  ArrayResize(bsmOOP, k);
  ArrayResize(bsmOSL, k);
  ArrayResize(bsmOTP, k);
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      bsmOTI[i]=OrderTicket();
      bsmOTY[i]=OrderType();
      bsmOOP[i]=OrderOpenPrice();
      bsmOSL[i]=OrderStopLoss();
      bsmOTP[i]=OrderTakeProfit();
    }
  }
}

//+----------------------------------------------------------------------------+
//|                       |
//|  :                                                                |
//|    ti -  ,                                               |
//|    sy -     ("" -  )                   |
//|    op -                    (-1 -  )                    |
//|    mn - MagicNumber                (-1 -  )                      |
//+----------------------------------------------------------------------------+
bool SelectByTicketFromHistory(int ti, string sy="", int op=-1, int mn=-1) {
  int i, k=OrdersHistoryTotal();

  if (sy=="") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) {
      if (OrderSymbol()==sy && (op<0 || OrderType()==op)) {
        if ((mn<0 || OrderMagicNumber()==mn) && OrderTicket()==ti) return(True);
      }
    }
  }
  return(False);
}
//+----------------------------------------------------------------------------+

